Type LightingDS
Field Typ%
Field P1%,P2%,MCam%
Field Mesh%,Surf%,Lens%
Field Size#,Noise%,Segments%,Tiles#
Field Dist#
Field X1#,Y1#,Z1#
Field X2#,Y2#,Z2#
Field Obj1%,Obj2%
Field Vert1%[256]
Field Vert2%[256]
Field Texture%,Fr%,Ind%,XM#,YM#,XP#,YP#
Field AutoSize%,SegLen#,TileLen#
End Type



Function LightingAutosizeDS(Lighting%,On_Off%,SegmentLenght#,TileLenght#)
For DS.LightingDS=Each LightingDS
If Lighting%=DS\Mesh
DS\AutoSize%=On_Off
DS\SegLen#=SegmentLenght#
DS\TileLen#=TileLenght#
EndIf
Next
End Function

Function LightingTextureDS(Lighting%,Tex%,XMove#=0,YMove#=0.03,Frame%=0,Ind%=0)
For DS.LightingDS=Each LightingDS
If Lighting%=DS\Mesh
DS\Texture%=Tex%
DS\Fr%=Frame%
DS\Ind%=Ind%
DS\XM#=XMove#
DS\YM#=YMove#
EntityTexture DS\Mesh,DS\Texture%,DS\Fr%,DS\Ind%
Exit
EndIf
Next
End Function



Function CreateObjectLightingDS%(Obj1%,Obj2%,MCam%,Size#=1,Noise%=50,Segments%=10,Tiles#=1.5)
Local J,RndX#,RndY#,RndZ#
DS.LightingDS=New LightingDS
DS\P1=CreatePivot()
DS\P2=CreatePivot()
DS\Size#=Size#
DS\Noise%=Noise%
DS\Segments%=Segments%
DS\Tiles#=Tiles#
DS\MCam%=Mcam%
DS\Obj1%=Obj1%
DS\Obj2%=Obj2%
DS\X1#=EntityX#(DS\Obj1%,1)
DS\Y1#=EntityY#(DS\Obj1%,1)
DS\Z1#=EntityZ#(DS\Obj1%,1)
DS\X2#=EntityX#(DS\Obj2%,1)
DS\Y2#=EntityY#(DS\Obj2%,1)
DS\Z2#=EntityZ#(DS\Obj2%,1)
PositionEntity DS\P1,DS\X1#,DS\Y1#,DS\Z1#,1
PositionEntity DS\P2,DS\X2#,DS\Y2#,DS\Z2#,1
DS\Dist=EntityDistance(DS\P1,DS\P2)
DS\Mesh=CreateMesh()
DS\Surf=CreateSurface(DS\Mesh)
For J=1 To DS\Segments%+1
RndX#=Rnd(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%*(-1),DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%)*2
RndY#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%),(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%))*2
RndZ#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%,DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%
If (J=1) RndX#=0:RndY#=0:RndZ#=DS\Dist#/(DS\Segments%+1)*-1
If (J=DS\Segments%+1) RndX#=0:RndY#=0:RndZ#=0 
DS\Vert1[J]=AddVertex (DS\Surf%,RndX#-1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),0,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
DS\Vert2[J]=AddVertex (DS\Surf%,RndX#+1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),1,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
If J>1 
AddTriangle DS\Surf%,DS\Vert1[J-1],DS\Vert1[J],DS\Vert2[J-1]
AddTriangle DS\Surf%,DS\Vert1[J],DS\Vert2[J],DS\Vert2[J-1]
EndIf
Next
PositionEntity DS\Mesh,DS\X1#,DS\Y1#,DS\Z1#,1
PointEntity DS\Mesh,DS\P2
RotateEntity DS\Mesh,EntityPitch#(DS\Mesh,1),EntityYaw#(DS\Mesh,1),-ATan2(EntityZ#(DS\MCam,1),EntityY#(DS\MCam,1)),1
EntityFX DS\mesh,1+16+32
EntityOrder DS\mesh,-1
Return DS\mesh
End Function



Function CreatePointLightingDS%(X1#,Y1#,Z1#,X2#,Y2#,Z2#,MCam%,Size#=1,Noise%=50,Segments%=10,Tiles#=1.5)
Local J,RndX#,RndY#,RndZ#
DS.LightingDS=New LightingDS
DS\Typ=1
DS\P1=CreatePivot()
DS\P2=CreatePivot()
DS\Size#=Size#
DS\Noise%=Noise%
DS\Segments%=Segments%
DS\Tiles#=Tiles#
DS\MCam%=Mcam%
DS\X1#=X1#
DS\Y1#=Y1#
DS\Z1#=Z1#
DS\X2#=X2#
DS\Y2#=Y2#
DS\Z2#=Z2#
PositionEntity DS\P1,DS\X1#,DS\Y1#,DS\Z1#,1
PositionEntity DS\P2,DS\X2#,DS\Y2#,DS\Z2#,1
DS\Dist=EntityDistance(DS\P1,DS\P2)
DS\Mesh=CreateMesh()
DS\Surf=CreateSurface(DS\Mesh)
For J=1 To DS\Segments%+1
RndX#=Rnd(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%*(-1),DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%)*2
RndY#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%),(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%))*2
RndZ#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%,DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%
If (J=1) RndX#=0:RndY#=0:RndZ#=DS\Dist#/(DS\Segments%+1)*-1
If (J=DS\Segments%+1) RndX#=0:RndY#=0:RndZ#=0
DS\Vert1[J]=AddVertex (DS\Surf%,RndX#-1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),0,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
DS\Vert2[J]=AddVertex (DS\Surf%,RndX#+1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),1,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
If J>1 
AddTriangle DS\Surf%,DS\Vert1[J-1],DS\Vert1[J],DS\Vert2[J-1]
AddTriangle DS\Surf%,DS\Vert1[J],DS\Vert2[J],DS\Vert2[J-1]
EndIf
Next
PositionEntity DS\Mesh,DS\X1#,DS\Y1#,DS\Z1#,1
PointEntity DS\Mesh,DS\P2
RotateEntity DS\Mesh,EntityPitch#(DS\Mesh,1),EntityYaw#(DS\Mesh,1),-ATan2(EntityZ#(DS\MCam,1),EntityY#(DS\MCam,1)),1
EntityFX DS\mesh,1
Return DS\mesh
End Function



Function UpdateLightingDS()
Local J,RndX#,RndY#,RndZ#
Local X1#,Y1#,Z1#,X2#,Y2#,Z2#
For DS.LightingDS=Each LightingDS

If DS\Typ=0
X1#=EntityX#(DS\Obj1%,1)
Y1#=EntityY#(DS\Obj1%,1)
Z1#=EntityZ#(DS\Obj1%,1)
X2#=EntityX#(DS\Obj2%,1)
Y2#=EntityY#(DS\Obj2%,1)
Z2#=EntityZ#(DS\Obj2%,1)
PositionEntity DS\P1,X1#,Y1#,Z1#,1
PositionEntity DS\P2,X2#,Y2#,Z2#,1
DS\Dist#=EntityDistance(DS\P1,DS\P2)
EndIf

If DS\AutoSize%
DS\Segments%=DS\Dist#/DS\SegLen#
DS\Tiles#=DS\Dist#/DS\TileLen#
EndIf

ClearSurface DS\Surf
For J=1 To DS\Segments%+1
RndX#=Rnd(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%*(-1),DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%)*2
RndY#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%),(DS\Dist#/(DS\Segments%+1)/2*.01*DS\Noise%))*2
RndZ#=Rnd(-1*(DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%,DS\Dist#/(DS\Segments%+1)/2)*.01*DS\Noise%
If (J=1) RndX#=0:RndY#=0:RndZ#=DS\Dist#/(DS\Segments%+1)*-1
If (J=DS\Segments%+1) RndX#=0:RndY#=0:RndZ#=0
DS\Vert1[J]=AddVertex (DS\Surf%,RndX#-1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),0,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
DS\Vert2[J]=AddVertex (DS\Surf%,RndX#+1*(DS\Size#/2),RndY#,RndZ#+J*(DS\Dist#/(DS\Segments%+1)),1,(DS\Tiles#/(DS\Segments%+1))*(J-1) )
If J>1 
AddTriangle DS\Surf%,DS\Vert1[J-1],DS\Vert1[J],DS\Vert2[J-1]
AddTriangle DS\Surf%,DS\Vert1[J],DS\Vert2[J],DS\Vert2[J-1]
EndIf
Next

If DS\Typ=1
RotateEntity DS\Mesh,EntityPitch#(DS\Mesh,1),EntityYaw#(DS\Mesh,1),-ATan2(EntityZ#(DS\MCam,1),EntityY#(DS\MCam,1)),1
Else
PositionEntity DS\Mesh,EntityX#(DS\Obj1%,1),EntityY#(DS\Obj1%,1),EntityZ#(DS\Obj1%,1),1
PointEntity DS\Mesh,DS\Obj2%
RotateEntity DS\Mesh,EntityPitch#(DS\Mesh,1),EntityYaw#(DS\Mesh,1),(-1*ATan2(EntityZ#(DS\MCam,1),EntityY#(DS\MCam,1))),1
EndIf

DS\XP#=DS\XP#+DS\XM#
DS\YP#=DS\YP#+DS\YM#
PositionTexture DS\Texture%,DS\XP#,DS\YP#

Next
End Function



Function DeleteLightingDS(Lighting%)
For DS.LightingDS=Each LightingDS
If Lighting%=DS\Mesh
FreeEntity DS\Mesh
FreeEntity DS\P1
FreeEntity DS\P2
Delete DS
Exit
EndIf
Next
End Function